﻿using Newtonsoft.Json;
using System;
using System.Collections;
using System.Numerics;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Security.Cryptography.X509Certificates;
using GrapeCity.Documents.Excel;
using GrapeCity.Documents.Excel.Expressions;
using GrapeCity.Documents.Excel.Drawing;
using System.Globalization;

namespace WebServiceAndFilterXml
{
	class Program
	{
		static void Main(string[] args)
		{
			//Create a new workbook
			var workbook = new GrapeCity.Documents.Excel.Workbook();
			//Fetch worksheet
			IWorksheet ws = workbook.Worksheets[0];
			
			ws.Range["A1"].Value = "URL";
			//URL of Webservice
			ws.Range["B1"].Value = "https://w1.weather.gov/xml/current_obs/KAKR.xml";
			ws.Range["A2"].Value = "Data Fetched from URL (WEBSERVICE Function)";
			ws.Range["A2"].VerticalAlignment = VerticalAlignment.Center;
			//Use WEBSERVICE Function
			ws.Range["B2"].Formula = "=WEBSERVICE(B1)";
			//Wrap the XML string returned by WEBSERVICE Function
			ws.Range["B2"].WrapText = true;
			ws.Range["B2"].RowHeight = 200;

			//Add labels for resultant values from FILTERXML formula
			ws.Range["A4"].Value = "Location";
			ws.Range["A5"].Value = "Observation Time";
			ws.Range["A6"].Value = "Weather";
			ws.Range["A7"].Value = "Temperature";			
			
			//Fetch Location using '//location' XPath Expression
			ws.Range["B4"].Formula = "=FILTERXML(B2,\"//location\")";

			//Fetch Observation Time using '//observation_time' XPath Expression
			ws.Range["B5"].Formula = "=FILTERXML(B2,\"//observation_time\")";

			//Fetch Weather using '//weather' XPath Expression
			ws.Range["B6"].Formula = "=FILTERXML(B2,\"//weather\")";

			//Fetch Temperature using '//temperature_string' XPath Expression
			ws.Range["B7"].Formula = "=FILTERXML(B2,\"//temperature_string\")";
			
			//Apply Formatting
			ws.Range["A4:A7"].Interior.Color = Color.FromArgb(88, 132, 52);
			ws.Range["A4:A7"].Font.Color = Color.White;
			ws.Range["B4:B7"].Interior.Color = Color.FromArgb(226, 239, 218);
			ws.Range["A4:B7"].Font.Bold = true;
			ws.Range["A4:B7"].Font.Size = 12;
			//Auto fit columns
			ws.Range["A:B"].EntireColumn.AutoFit();
			//Save to an Excel file
			workbook.Save("webserviceandfilterxml.xlsx");

		}

	}
}